Summary: 	Load balance and fail over utility for TCP based services
Name: 		crossroads
Version: 	2.65
Release: 	1.2
License: 	GPLv3
Group: 		Applications/Utilities
URL: 		http://crossroads.e-tunity.com/

Source: 	http://crossroads.e-tunity.com/downloads/versions/crossroads-stable.tar.gz
BuildRoot: 	%{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: 	perl yodl gcc-c++
Requires: 	perl

%description
Crossroads is an open source load balance and fail over utility for TCP based 
services. It is a daemon running in user space, and features extensive 
configurability, polling of back ends using 'wakeup calls', detailed status 
reporting, 'hooks' for special actions when backend calls fail, and much more. 
Crossroads is service-independent: it is usable for HTTP(S), SSH, SMTP, DNS, 
etc.. In the case of HTTP balancing, Crossroads can provide 'session 
stickiness' for back end processes that need sessions, but aren't session-aware 
of other back ends.

%prep
%setup -n %{name}-%{version}

%build
%{__make} %{?_smp_mflags} PREFIX=%{_prefix} local
#needs yo2man
#{__make} %{?_smp_mflags} PREFIX=%{_prefix} documentation

%install
%{__rm} -rf %{buildroot}
%{__install} -d %{buildroot}%{_sbindir} %{buildroot}%{_bindir}
%{__make} install DESTDIR="%{buildroot}"
%__install -m 0755 xrctl/xrctl %{buildroot}%{_sbindir}/xrctl

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-, root, root, 0755)
%doc ChangeLog
%doc doc/xr.pdf doc/xr.odt
%{_sbindir}/xr
%{_sbindir}/xrctl
%{_mandir}/man1/xr.1.gz
%{_mandir}/man1/xrctl.1.gz
%{_mandir}/man5/xrctl.xml.5.gz

%changelog
* Thu Jul 29 2010 Carsten Schoene <cs@linux-administrator.com> - 2.65-1
2.65 [KK 2010-04-26]
- Bugfix in backend/connect.cc - if the determination whether a back
  end is available goes haywire, the client socket may stay open and
  not be consumed. Thanks Franz J. for reporting!
- Version stamped as STABLE.

* Thu Jan 21 2009 Carsten Schoene <cs@linux-administrator.com> - 2.62-1
2.62 [KK 2010-01-08]
- Fixed possible coredump cause in Balancer::serve(), which might
  explain some troubles during high load (many really concurrent requests).

2.61 [KK 2009-11-17]
- Netbuffer::netwrite() will abort after 5 attempts that yield 0
  written bytes. Probable cause of CPU hogging - thx Franz J. for
  reporting.
- Fixed potential cause of crashes in base class for Dispatcher
  (algorithm handler would not get initialized in the constructors).

2.60 [KK 2009-11-02]
- Some errors demoted to informational messages to choke the amount of
  log information that's generated.

2.59 [KK 2009-10-14]
- Bugfix in logger handling of xrctl, read
  http://xrforum.org/viewtopic.php?t=495 if you fancy. Thanks Hobbit
  for reporting this!
  
2.58 [KK 2009-10-14] 
- Added test/ftp.xml as a sample ftp service configuration.
- Implemented URL-based dispatching: flag --url-match/-j, present in
  xrctl, tested in test/urlmatch.xml, added to web interface
- Usage information now shows long versions of flags first.

2.57 [KK 2009-09-14]
- Output of "xrctl status" colorized when a service is not running,
  thanks Frederik D. for the suggestion and the code!
- Small cleanup of xrctl's usage information.  

2.56 [KK 2009-05-26]
- Bugfix in cleaning of IPStore map
- Implemented flag --remove-reservations (xrctl: tag: removereservations)
- Timeouts adjusted: all read time outs set to 30, client-write set to
  5, backend-write set to 3
- Implemented tag prefixtimestamp in system block to force timestamping.  

2.55 [KK 2009-05-13] 
- Implemented connection error counting of back ends.
- Select-handling revised: atomic readability and writeability checks,
  see xr/fdset/wait.cc and wait_r(), wait_w(), wait_rw().
- Checks for connect() success can be configured to verify only
  writeable status of a socket (see xr/backend/connect.cc, macro
  CONNECTCHECK_ONLY_WRITABLE in xr/etc/Makefile.class).
- Added test/xr-mysql-connect.
- Added commands kill and killstart to xrctl. Action restart renamed
  to stopstart.
- Added simple benchmarking under test/: xr-http-test (based on an
  older script) and xr-smtp-test. Plus a simple analyzer of the
  reported timings, xr-analyze-test.
- Revamped stored-ip dispatcher, added IPStore class to keep track of clients.  

2.54 [KK 2009-04-29]
- Stamped new STABLE version.

2.53 [KK 2009-04-24]
- test/xr-client-ping now can live without LWP::UserAgent. When this
  Perl module is not present, the script will fall back to wget/curl.
- Upon thread kill, sockets are closed using socketclose()
  (sys/socketclose.cc), which also shutdown()s the socket.
- Bugfix in xrctl regarding new format of client/backend timeout.  

2.52 [KK 2009-04-21]
- Bugfix in the roundrobin dispatcher. When only one back end would be
  up, then the roundrobin dispatcher would incorrectly compute the
  right back end. This bug only became visible with host-matching in
  HTTP mode.

2.51 [KK 2009-04-15]
- Separate "write" timeouts introduced in flags -t and -T
- Web interface activity overview includes client ip addresses
- Added test/xr-client-ping (see docs)

2.50 [KK 2009-03-30]
- Bugfix in activation of the onfail script in the checkup thread.
- Compilation flag -Werror only passed to the compiler when on the
  development system Thera.local (see xr/etc/Makefile.class).
- Onstart, onend and onfail scripts (when present) are invoked with a
  third argument, the number of connections at the time
- Set-Cookie header directive (see the HTTP dispatcher) attaches an
  explicit path "/".
- Rewired the tcp dispatcher and http dispatcher to use a common
  buffer inside the tcp dispatcher (instead of 2 separate ones).

2.49 [KK 2009-03-27]
- Implemented onfail hook (to complement onstart/onend, flag -y).

2.48 [KK 2009-03-26]
- Implemented onstart/onend hooks (flags -z, -Z).
- Sticky HTTP mode inspects the URI (parameter XRTarget) when no
  sticky cookie is present.

2.47 [KK 2009-03-04]
- Stored-ip dispatching was enhanced to "anticipate" reconnects from
  previously seen clients. The number of anticipated connections is taken
  into account when dispatching a new client.
- Bugfix in command line parsing of dispatch mode lax-stored-ip (would
  be recognized as strict).
  
2.46 [KK 2009-02-18]
- Dispatcher-related classes moved under directory xr/Dispatchers/.
- UDP balancer implementation started (code stubs in place).
- xrctl bugfixed: a backend-scope maxconnections statement would
  confuse the global server block. Thanks Rajeev for reporting.

2.45 [KK 2009-02-18]
- Usage information formatted.
- Rubberstamped "stable"!

2.44 [KK 2009-02-11] 
- Reviewed code for "throw"s (edited for consistency).
- Bug in Webinterface::execute() (during accept()). Thanks Vladimir T.
  for reporting and testing.

2.43 [KK 2009-02-09] 
- Added Httpbuffer::replaceheader() methods
- Added flag -I (to replace Host: headers), integrated in xrctl /
  webinterface
- Webinterface reports approx. # of open fd's and the limit (in activity)

2.42 [KK 2009-01-28] 
- Bugfix in "xrctl generateconfig". The activity info introduced
  before (which the web interface now emites), confused xrctl.
- Bugfix in sys/ipmatch.cc: mask matching corrected for systems where
  longs are not 4 bytes (64bit systems).
- Bugfix in hashed-ip dispatch mode: When no back ends were available,
  the dispatcher would crash (fixed).
- XSLT stylesheet that transforms web interface slightly changed to
  improve the looks.
- Bugfix in xrctl's "rotate" action. Thanks "ncisrael" for reporting
  it in the forum.

2.41 [KK 2009-01-05]
- Bugfix in xrctl, thanks Eddie for reporting it.    

2.40 [KK 2009-01-03] 
- Netbuffer::read() failures are no longer logged as errors, but as
  verbose messages.
- XML configuration now supports "logger" to redefine logger program.
- Small changes to xrctl: ps command is auto-guessed when not
  specified in the XML configuration.

2.39 [KK 2008-12-04] 
- Added Httpbuffer::reset()
- The HTTP dispatcher will show back end error returns (when the HTTP
  code is in the 400 or 500 range)
- main() will show runtime limits when invoked with -v
- The HTTP dispatcher no longer downgrades to HTTP/1.0 and closed
  connections. Webserver back ends can do this.
- Exceptions during the sending of an error page in HTTP mode are
  discarded, no longer logged.
- Mutex lock added around thread startups (see Thread::start()), when
  requested soq in sys/sys.
- Mutex locks around malloc()/realloc(), when requested so in sys/sys.
- Fixed possible socket leak in TcpDispatcher::execute(). The back end
  socket might not have been closed when the dispatch phase crashed.
- Dispatchers are now derived from a new base class Dispatcher, in
  preparation for UDP handling.
- Timestamp handling centralized in a class Timestamp.
- Messaging (msg(), debugmsg(), reportmsg(), warnmsg()) centralized.
- Started threads are administered in Threadlist. Separate threads are
  killable from the web interface, or all threads to a given back end.

2.38 [KK 2008-11-19]
- Bugfix in xrctl: Weights and max connections in back ends are now
  passed correctly.
- Added version ID to xrctl.  

2.37 [KK 2008-11-17]
- Main accept-loop in Balancer::serve() doesn't throw an exception
  when a network connection can't be accepted. The reason is shown in
  a warnmsg().

2.36 [KK 2008-11-11]
- Typo bugfix in xrctl, fixed.
- xrctl will take the environment's PATH if no path is given in the
  configuration.
  
2.35 [KK 2008-11-11]
- The wakeup and checkup thread are always started, even when no
  wakeups or checkups are defined. Reason is that later these timers
  can be set in the web interface, so we want the threads running.
  When no checks/wakeups are applicable, the threads will recheck each
  30 secs.
- Server type (tcp/http) made configurable through the web interface.  

2.34 [KK 2008-11-09] 
- Fixed sys/str2parts.cc for 64bit systems.

2.33 [KK 2008-11-07] 
- Solaris portability for gcc 3.4 issues in Tcpdispatcher::execute()
- Removed warnings about non-found libraries (on systems that don't
  need them)
- Support for DESTDIR setting in top Makefile (for debian packaging)
- Man pages added as doc/xr.1, doc/xrctl.1 and doc/xrctl.xml.5.


* Mon Nov 03 2008 Carsten Schoene <cs@linux-administrator.com> - 2.30-1
- new upstream version 2.30
 - New features include DOS protection capabilities
 - bugfixes
 - a "weighted-load" dispatching mode
 - a richer management Web interface and a rewritten, optimized HTTP dispatcher which runs 40-50% faster.

* Wed Oct 08 2008 Carsten Schoene <cs@linux-administrator.com> - 2.18-1
- new upstream version 2.18, this is the new stable release
* Sat Aug 16 2008 Carsten Schoene <cs@linux-administrator.com> - 2.05-1
- new upstream version 2.05
* Fri Aug 08 2008 Carsten Schoene <cs@linux-administrator.com> - 2.00-1
- new upstream version 2.00
* Mon May 19 2008 Carsten Schoene <cs@linux-administrator.com> - 1.80-1
- new upstream version 1.80
* Mon Apr 21 2008 Carsten Schoene <cs@linux-administrator.com> - 1.79-1
- new upstream version 1.79
* Fri Mar 07 2008 Carsten Schoene <cs@linux-administrator.com> - 1.77-1
- Initial package.

